diff --git a/src/prepare.c b/src/prepare.c
index 0c1c2593..320978b5 100644
--- a/src/prepare.c
+++ b/src/prepare.c
@@ -48,26 +48,7 @@ static  zend_trait_method_reference * pthreads_preparation_copy_trait_method_ref
 static void pthreads_prepared_resource_dtor(zval *zv); /* }}} */
 
 /* {{{ */
-static zend_class_entry* pthreads_copy_entry(pthreads_object_t* thread, zend_class_entry *candidate) {
-	zend_class_entry *prepared;
-
-	if (candidate->ce_flags & ZEND_ACC_ANON_CLASS) {
-		if (!(candidate->ce_flags & ZEND_ACC_ANON_BOUND)) {
-			return NULL;
-		}
-	}
-
-	prepared = (zend_class_entry*) emalloc(sizeof(zend_class_entry));
-	prepared->name = zend_string_new(candidate->name);
-	prepared->type = candidate->type;
-
-	zend_initialize_class_data(prepared, 1);
-
-	zend_hash_index_update_ptr(&PTHREADS_ZG(resolve), (zend_ulong) candidate, prepared);
-
-	prepared->ce_flags = candidate->ce_flags;
-	prepared->refcount = 1;
-
+static zend_class_entry* pthreads_complete_entry(pthreads_object_t* thread, zend_class_entry *candidate, zend_class_entry *prepared) {
 	if (candidate->parent) {
 		if (zend_hash_index_exists(&PTHREADS_ZG(resolve), (zend_ulong) candidate->parent)) {
 			prepared->parent = zend_hash_index_find_ptr(&PTHREADS_ZG(resolve), (zend_ulong) candidate->parent);
@@ -164,9 +145,12 @@ static zend_class_entry* pthreads_copy_entry(pthreads_object_t* thread, zend_cla
 		
 		ZEND_HASH_FOREACH_STR_KEY_PTR(&candidate->function_table, key, value) {	
 			zend_string *name = zend_string_new(key);
-			value = pthreads_copy_function(value);
-			zend_hash_add_ptr(
-				&prepared->function_table, name, value);
+			
+			if (!zend_hash_exists(&prepared->function_table, name)) {
+				value = pthreads_copy_function(value);
+				zend_hash_add_ptr(
+					&prepared->function_table, name, value);
+			}
 			zend_string_release(name);
 		} ZEND_HASH_FOREACH_END();
 	}
@@ -256,6 +240,10 @@ while(0)
 	
 	if (candidate->default_properties_count) {
 		int i;
+		
+		if(prepared->default_properties_table != NULL) {
+			efree(prepared->default_properties_table);
+		}
 		prepared->default_properties_table = emalloc(
 			sizeof(zval) * candidate->default_properties_count);
 
@@ -276,6 +264,9 @@ while(0)
 
 	if (candidate->default_static_members_count) {
 		int i;
+		if(prepared->default_static_members_table != NULL) {
+			efree(prepared->default_static_members_table);
+		}
 		prepared->default_static_members_table = (zval*) ecalloc(
 			sizeof(zval), candidate->default_static_members_count);
 		prepared->default_static_members_count = candidate->default_static_members_count;
@@ -291,16 +282,6 @@ while(0)
 		prepared->static_members_table = prepared->default_static_members_table;
 	} else prepared->default_static_members_count = 0;
 
-	memcpy(&prepared->info.user, &candidate->info.user, sizeof(candidate->info.user));
-
-	if ((thread->options & PTHREADS_INHERIT_COMMENTS) &&
-	   (candidate->info.user.doc_comment)) {
-        	prepared->info.user.doc_comment = zend_string_new(candidate->info.user.doc_comment);
-    	} else prepared->info.user.doc_comment = NULL;
-	
-	if (prepared->info.user.filename)
-		prepared->info.user.filename = zend_string_new(candidate->info.user.filename);
-
 	{
 		zend_string *key;
 		zval *value;
@@ -352,6 +333,35 @@ while(0)
 	return prepared;
 } /* }}} */
 
+/* {{{ */
+static zend_class_entry* pthreads_copy_entry(pthreads_object_t* thread, zend_class_entry *candidate) {
+	zend_class_entry *prepared;
+
+	prepared = (zend_class_entry*) emalloc(sizeof(zend_class_entry));
+	prepared->name = zend_string_new(candidate->name);
+	prepared->type = candidate->type;
+
+	zend_initialize_class_data(prepared, 1);
+
+	zend_hash_index_update_ptr(&PTHREADS_ZG(resolve), (zend_ulong) candidate, prepared);
+
+	prepared->ce_flags = candidate->ce_flags;
+	prepared->refcount = 1;
+	
+	memcpy(&prepared->info.user, &candidate->info.user, sizeof(candidate->info.user));
+
+	if ((thread->options & PTHREADS_INHERIT_COMMENTS) &&
+	   (candidate->info.user.doc_comment)) {
+        	prepared->info.user.doc_comment = zend_string_new(candidate->info.user.doc_comment);
+    	} else prepared->info.user.doc_comment = NULL;
+	
+	if (prepared->info.user.filename) {
+		prepared->info.user.filename = zend_string_new(candidate->info.user.filename);
+	}
+	
+	return pthreads_complete_entry(thread, candidate, prepared);
+} /* }}} */
+
 /* {{{ */
 static inline int pthreads_prepared_entry_function_prepare(zval *bucket, int argc, va_list argv, zend_hash_key *key) {
 	zend_function *function = (zend_function*) Z_PTR_P(bucket);
@@ -398,6 +408,10 @@ zend_class_entry* pthreads_prepared_entry(pthreads_object_t* thread, zend_class_
 
 	if ((prepared = zend_hash_find_ptr(EG(class_table), lookup))) {
 	    zend_string_release(lookup);
+		
+		if(prepared->create_object == NULL && candidate->create_object != NULL) {
+			return pthreads_complete_entry(thread, candidate, prepared);
+		}
 		return prepared;
 	}
 	
